;****************************************************
;lab3
;approx 2 ms delay program with 2 status leds to show
;start and end of delay.
;will use tmr0 peripheral
;****************************************************

	List P=12f508, R=hex
	include "P12f508.inc"		;load the include file
	__CONFIG _IntRC_OSC & _WDT_OFF & _CP_OFF & _MCLRE_ON

		cblock	0x07
	COUNTER
		endc

		org	0x00
	movwf	OSCCAL		;setup INTRC calibration
	goto	Start		;

;===========================================================
;call routines

;routine to preload tmr0
Settmr0
	movlw	0x37		;reset tmr0 to count d'55'
	movwf	TMR0		;could use clrf here but this
	retlw	0x01		;lets you put in test/spec values

;routine to preload counter
Setcounter
	movlw	0x0A		;set # of tmr0 roll overs needed
	movwf	COUNTER		;
	retlw	0x01


;routine to decrement counter
	;write a routine to decrement counter and see if 2 ms has expired
	;if 2 msec has expired, call the routine to light the 2nd led

	;don't forget to reload tmr0 if 2 ms has not expired

Decr_counter

;	<//place your code here//>


	retlw	0x01

;routine to light the 2nd led
Light_2nd_led
	bsf	GPIO,5		;light time expires led
	retlw	0x01

;===========================================================
	
Start
	;initialize tmr0 peripheral

;	<//place your code here//>

Gpio	;initialize gpio port 

;	<//place your code here//>

Initvar	;initialize temp variables used

;	<//place your code here//>


Runled	;set 1st led to indicate program running

;	<//place your code here//>	




Test_tmr0
	;loop to test to see if trm0 has rolled over
	;
	;you will need to compensate for missing the roll
	;over during your test loop by using a sample window

;	<//place your code here//>


	end
